package org.openjdk.gcbench.tests;

import org.openjdk.gcbench.MaxHeapDetector;

public class Dimensions {

    public static Dimension heapSize(int min, int max, int step) {
        return new Dimension(DimensionType.HEAPSIZE, Sequence.steps(min, max, step));
    }

    public static Dimension heapSize(int steps) {
        int maxHeap = MaxHeapDetector.MAX_HEAP;
        return heapSize(maxHeap / 16, maxHeap - maxHeap / 16, steps);
    }

    public static Dimension lds(int steps) {
        int maxHeap = MaxHeapDetector.MAX_HEAP;
        return new Dimension(DimensionType.LDS,
                Sequence.steps(maxHeap / 16, maxHeap - maxHeap / 16, steps));
    }

    public static Dimension size(Sequence seq) {
        return new Dimension(DimensionType.SIZE, seq);
    }

    public static Dimension threads() {
        return new Dimension(DimensionType.THREADS, Sequence.powersOfTwo(1, Runtime.getRuntime().availableProcessors()));
    }

    public static Dimension jvmMode() {
        return new Dimension(DimensionType.JVM_MODE, Sequence.jvmModes());
    }

    public static Dimension javaType() {
        return new Dimension(DimensionType.JAVA_TYPE, Sequence.javaType());
    }
}
